# Importion of modules
import os
import sys
import random

import pygame

import letters

# Initialize pygame
pygame.init()

class Countdown( pygame.sprite.Sprite ):
	"""
	"""

	def __init__( self, topleft, max_time, add_string, size ):
		"""
		"""
		pygame.sprite.Sprite.__init__( self )


		self.max_time = max_time # in seconds
		self.internal_counter = max_time # counts up to 60 / 1 sec, that is.
		self.one_second = 60

		self.red_color = 0
		self.green_color = 255

		self.size = size

		self.topleft = topleft
		self.add_string = add_string
		
		self.reset_timer()
		self.draw_time()
		
		
	def reset_timer( self ):
		"""
		This method resets the timer.
		"""

		self.time_left = self.max_time


	def update( self ):
		"""
		Updates the timer.
		"""

		if self.time_left <= 0:
			self.reset_timer()
			self.draw_time()
			return True

		else:
			if self.internal_counter >= self.one_second:
				self.internal_counter = 0
				self.time_left -= 1
				self.draw_time()
			else:
				self.internal_counter += 1
				
			return False


	def draw_time( self ):
		"""
		Draws the time on the surface.
		"""

		self.red_color = ( 255 / float( self.max_time ) ) * ( self.max_time - self.time_left )
		self.green_color = ( 255 / float ( self.max_time ) ) * self.time_left
		

		time = letters.Word( self.add_string + str( self.time_left ), self.topleft, ( ( self.red_color, self.green_color, 20 ) ), self.size )
		self.image = time.image
		self.rect = time.rect

