# Importion of modules
import os
import sys
import random

import pygame

import letters

# Initialize pygame
pygame.init()

class Receipe( pygame.sprite.Sprite ):
	"""
	A thought receipe by the scientist, the MAD scientist.
	"""

	def __init__( self ):
		"""
		"""
		pygame.sprite.Sprite.__init__( self )

		self.image = pygame.Surface( ( 520, 200 ) )
		self.rect = self.image.get_rect( topleft = ( 190, 90 ) )

		self.allowance = 5 # in %

		self.generate_receipe()
		self.blit_receipe()


	def generate_receipe( self ):
		"""
		"""

		self.blue_liquid = random.randint( 100, 100000 )
		self.yellow_liquid = random.randint( 100, 100000 )
		self.purple_liquid = random.randint( 100, 100000 )
		self.green_liquid = random.randint( 100, 100000 )


	def blit_receipe( self ):
		"""
		Blits the receipe.
		"""

		yellow_liquid_allowance = self.yellow_liquid / 100 * self.allowance
		purple_liquid_allowance = self.purple_liquid / 100 * self.allowance
		blue_liquid_allowance = self.blue_liquid / 100 * self.allowance
		green_liquid_allowance = self.green_liquid / 100 * self.allowance

		scientist_saying_p1 = letters.Word( "MAD SCIENTISTS. THEY HAVE SO MANY THOUGHTS", ( 0, 0 ), ( ( 255, 255, 255 ) ), 2 )
		scientist_saying_p2 = letters.Word( "AND IDEAS RUSHING THROUGH THEIR MINDS", ( 0, 20 ), ( ( 255, 255, 255 ) ), 2 )
		scientist_saying_p3 = letters.Word( "WHICH THEY JUST HAVE TO TRY.", ( 0, 40 ), ( ( 255, 255, 255 ) ), 2 )
				
		scientist_thought_p1 = letters.Word( "\"I HAVE IN MY MIND A NEW SCIENTIFIC", ( 0, 80 ), (( 255, 255, 255 )), 2 )
		scientist_thought_p2 = letters.Word( "RECIPE TO TRY\"", ( 0, 100 ), (( 255, 255, 255 )), 2 )
		parts_yellow = letters.Word( "YELLOW" + " " + str( self.yellow_liquid ) + " +- " + str( yellow_liquid_allowance ), ( 0, 120 ), (( 230, 200, 0 )), 2 )
		parts_purple = letters.Word( "PURPLE" + " " + str( self.purple_liquid) + " +- " + str( purple_liquid_allowance ), ( 0, 140 ), (( 230, 0, 200 )), 2 )
		parts_blue = letters.Word( "BLUE" + " " + str( self.blue_liquid ) + " +- " + str( blue_liquid_allowance ), ( 0, 160 ), (( 20, 40, 240 )), 2 )
		parts_green = letters.Word( "GREEN" + " " + str( self.green_liquid ) + " +- " + str( green_liquid_allowance ), ( 0, 180 ), (( 20, 230, 30 )), 2 )
		

		self.image.blit( scientist_saying_p1.image, scientist_saying_p1.rect )
		self.image.blit( scientist_saying_p2.image, scientist_saying_p2.rect )		
		self.image.blit( scientist_saying_p3.image, scientist_saying_p3.rect )

		self.image.blit( scientist_thought_p1.image, scientist_thought_p1.rect )
		self.image.blit( scientist_thought_p2.image, scientist_thought_p2.rect )		
		self.image.blit( parts_yellow.image, parts_yellow.rect )
		self.image.blit( parts_purple.image, parts_purple.rect )
		self.image.blit( parts_blue.image, parts_blue.rect )
		self.image.blit( parts_green.image, parts_green.rect )


	def update( self, events, total_yellow_liquid, total_purple_liquid, total_blue_liquid, total_green_liquid ):
		"""
		"""

		for event in events:
			if event.type == pygame.KEYDOWN:
				if event.key == pygame.K_d:
					if self.check( total_yellow_liquid, total_purple_liquid, total_blue_liquid, total_green_liquid ):
						return True


	def check( self, total_yellow_liquid, total_purple_liquid, total_blue_liquid, total_green_liquid ):
		"""
		When called, this function checks if the scientist has accomplished his task of trying the receipe.
		"""

		yellow_liquid_allowance = self.yellow_liquid / 100 * self.allowance
		purple_liquid_allowance = self.purple_liquid / 100 * self.allowance
		blue_liquid_allowance = self.blue_liquid / 100 * self.allowance
		green_liquid_allowance = self.green_liquid / 100 * self.allowance
						

		if 	self.in_allowance( self.yellow_liquid, total_yellow_liquid, yellow_liquid_allowance ) and self.in_allowance( self.purple_liquid, total_purple_liquid, purple_liquid_allowance ) and self.in_allowance( self.blue_liquid, total_blue_liquid, blue_liquid_allowance ) and self.in_allowance( self.green_liquid, total_green_liquid, green_liquid_allowance ):

			self.generate_receipe()
			self.image.fill( ( 0, 0, 0 ) )
			self.blit_receipe()

			return True

		else:
			return False				


	def in_allowance( self, compare_against, liquid_to_check, allowed_allowance ):
		"""
		Checks if the liquid is within the allowed allowance and returns either True or False.
		"""

		if liquid_to_check >= ( compare_against - allowed_allowance ) and liquid_to_check <= ( compare_against + allowed_allowance ):
			return True
		else:
			return False
		
